datablock ItemData(ShieldVikingItem : HammerItem) {
	shapeFile = "./Viking.dts";
	uiName = "Viking Shield";

	doColorShift = false;

	iconName = "./icon_viking";
	image = ShieldVikingImage;
};

datablock ShapeBaseImageData(ShieldVikingImage) {
	shapeFile = "./Viking.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 1;
	eyeOffset = 0; //"0.7 1.2 -0.5";

	className = "WeaponImage";
	item = ShieldVikingItem;

	//raise your arm up or not
	armReadyLeft = false;

	doColorShift = false;


	stateName[0]						= "Activate";
	stateScript[0]						= "onActivate";
	stateSound[0]						= "ShieldEquipSound";
	stateTimeoutValue[0]				= 0.9;
	stateTransitionOnTimeout[0]			= "Ready";

	stateName[1]						= "Ready";
	stateScript[1]						= "onReady";
	stateAllowImageChange[1]			= 1;
};

function ShieldVikingImage::onMount(%this, %obj, %slot) {
	%obj.shieldEquipped = 1;
	%obj.blockProjectiles = 0;
	// serverPlay3D(ShieldEquipSound, %obj.getHackPosition());
	%obj.unMountImage(0);
	%obj.playThread(1, root);
}

function ShieldVikingImage::onReady(%this, %obj, %slot) {
	if (isObject(%obj.getMountedImage(0))) {
		return;
	}
	%obj.playThread(2, armReadyLeft);
	%obj.blockProjectiles = 1;
}

function ShieldVikingImage::onUnmount(%this, %obj, %slot) {
	%obj.shieldEquipped = 0;
	%obj.blockProjectiles = 0;
	%obj.playThread(2, root);
}

////////////////////

datablock ItemData(ShieldScutumItem : ShieldVikingItem) {
	shapeFile = "./scutum.dts";
	uiName = "Scutum Shield";

	iconName = "./icon_scutum";
	image = ShieldScutumImage;
};

datablock ShapeBaseImageData(ShieldScutumImage : ShieldVikingImage) {
	shapeFile = "./scutum.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 1;
	eyeOffset = 0; //"0.7 1.2 -0.5";

	className = "WeaponImage";
	item = ShieldScutumItem;

	//raise your arm up or not
	armReadyLeft = false;

	doColorShift = false;


	stateName[0]						= "Activate";
	stateScript[0]						= "onActivate";
	stateSound[0]						= "ShieldEquipSound";
	stateTimeoutValue[0]				= 0.9;
	stateTransitionOnTimeout[0]			= "Ready";

	stateName[1]						= "Ready";
	stateScript[1]						= "onReady";
	stateAllowImageChange[1]			= 1;
};

function ShieldScutumImage::onMount(%this, %obj, %slot) {
	%obj.shieldEquipped = 1;
	%obj.blockProjectiles = 0;
	// serverPlay3D(ShieldEquipSound, %obj.getHackPosition());
	%obj.unMountImage(0);
	%obj.playThread(1, root);
}

function ShieldScutumImage::onReady(%this, %obj, %slot) {
	if (isObject(%obj.getMountedImage(0))) {
		return;
	}
	%obj.playThread(2, armReadyLeft);
	%obj.blockProjectiles = 1;
}

function ShieldScutumImage::onUnmount(%this, %obj, %slot) {
	%obj.shieldEquipped = 0;
	%obj.blockProjectiles = 0;
	%obj.playThread(2, root);
}

////////////////////

datablock ItemData(ShieldAspisItem : ShieldVikingItem) {
	shapeFile = "./Aspis.dts";
	uiName = "Aspis Shield";

	iconName = "./icon_Aspis";
	image = ShieldAspisImage;
};

datablock ShapeBaseImageData(ShieldAspisImage : ShieldVikingImage) {
	shapeFile = "./Aspis.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 1;
	eyeOffset = 0; //"0.7 1.2 -0.5";

	className = "WeaponImage";
	item = ShieldAspisItem;

	//raise your arm up or not
	armReadyLeft = false;

	doColorShift = false;


	stateName[0]						= "Activate";
	stateScript[0]						= "onActivate";
	stateSound[0]						= "ShieldEquipSound";
	stateTimeoutValue[0]				= 0.9;
	stateTransitionOnTimeout[0]			= "Ready";

	stateName[1]						= "Ready";
	stateScript[1]						= "onReady";
	stateAllowImageChange[1]			= 1;
};

function ShieldAspisImage::onMount(%this, %obj, %slot) {
	%obj.shieldEquipped = 1;
	%obj.blockProjectiles = 0;
	// serverPlay3D(ShieldEquipSound, %obj.getHackPosition());
	%obj.unMountImage(0);
	%obj.playThread(1, root);
}

function ShieldAspisImage::onReady(%this, %obj, %slot) {
	if (isObject(%obj.getMountedImage(0))) {
		return;
	}
	%obj.playThread(2, armReadyLeft);
	%obj.blockProjectiles = 1;
}

function ShieldAspisImage::onUnmount(%this, %obj, %slot) {
	%obj.shieldEquipped = 0;
	%obj.blockProjectiles = 0;
	%obj.playThread(2, root);
}

////////////////////

datablock ItemData(ShieldHeater_BlueItem : ShieldVikingItem) {
	shapeFile = "./Heater_Blue.dts";
	uiName = "Heater Shield - Blue";

	iconName = "./icon_heater_blue";
	image = ShieldHeater_BlueImage;
};

datablock ShapeBaseImageData(ShieldHeater_BlueImage : ShieldVikingImage) {
	shapeFile = "./Heater_Blue.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 1;
	eyeOffset = 0; //"0.7 1.2 -0.5";

	className = "WeaponImage";
	item = ShieldHeater_BlueItem;

	//raise your arm up or not
	armReadyLeft = false;

	doColorShift = false;


	stateName[0]						= "Activate";
	stateScript[0]						= "onActivate";
	stateSound[0]						= "ShieldEquipSound";
	stateTimeoutValue[0]				= 0.9;
	stateTransitionOnTimeout[0]			= "Ready";

	stateName[1]						= "Ready";
	stateScript[1]						= "onReady";
	stateAllowImageChange[1]			= 1;
};

function ShieldHeater_BlueImage::onMount(%this, %obj, %slot) {
	%obj.shieldEquipped = 1;
	%obj.blockProjectiles = 0;
	// serverPlay3D(ShieldEquipSound, %obj.getHackPosition());
	%obj.unMountImage(0);
	%obj.playThread(1, root);
}

function ShieldHeater_BlueImage::onReady(%this, %obj, %slot) {
	if (isObject(%obj.getMountedImage(0))) {
		return;
	}
	%obj.playThread(2, armReadyLeft);
	%obj.blockProjectiles = 1;
}

function ShieldHeater_BlueImage::onUnmount(%this, %obj, %slot) {
	%obj.shieldEquipped = 0;
	%obj.blockProjectiles = 0;
	%obj.playThread(2, root);
}

////////////////////

datablock ItemData(ShieldHeater_RedItem : ShieldVikingItem) {
	shapeFile = "./Heater_Red.dts";
	uiName = "Heater Shield - Red";

	iconName = "./icon_heater_red";
	image = ShieldHeater_RedImage;
};

datablock ShapeBaseImageData(ShieldHeater_RedImage : ShieldVikingImage) {
	shapeFile = "./Heater_Red.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 1;
	eyeOffset = 0; //"0.7 1.2 -0.5";

	className = "WeaponImage";
	item = ShieldHeater_RedItem;

	//raise your arm up or not
	armReadyLeft = false;

	doColorShift = false;


	stateName[0]						= "Activate";
	stateScript[0]						= "onActivate";
	stateSound[0]						= "ShieldEquipSound";
	stateTimeoutValue[0]				= 0.9;
	stateTransitionOnTimeout[0]			= "Ready";

	stateName[1]						= "Ready";
	stateScript[1]						= "onReady";
	stateAllowImageChange[1]			= 1;
};

function ShieldHeater_RedImage::onMount(%this, %obj, %slot) {
	%obj.shieldEquipped = 1;
	%obj.blockProjectiles = 0;
	// serverPlay3D(ShieldEquipSound, %obj.getHackPosition());
	%obj.unMountImage(0);
	%obj.playThread(1, root);
}

function ShieldHeater_RedImage::onReady(%this, %obj, %slot) {
	if (isObject(%obj.getMountedImage(0))) {
		return;
	}
	%obj.playThread(2, armReadyLeft);
	%obj.blockProjectiles = 1;
}

function ShieldHeater_RedImage::onUnmount(%this, %obj, %slot) {
	%obj.shieldEquipped = 0;
	%obj.blockProjectiles = 0;
	%obj.playThread(2, root);
}

////////////////////

package SwordShield {
	function Weapon::onUse(%db, %obj, %itemSlot) {
		if (%obj.shieldEquipped && !%db.allowShield) {
			%obj.unMountImage(1);
		} else {
			%obj.unMountImage(0);
			%obj.blockProjectiles = 0;
			%obj.playThread(2, root);
		}

		return parent::onUse(%db, %obj, %slot);
	}

	function serverCmdUnUseTool(%cl, %slot) {
		parent::serverCmdUnUseTool(%cl, %slot);

		if (%cl.player.shieldEquipped) {
			%cl.player.unMountImage(1);
		}
	}

	function serverCmdUseTool(%cl, %slot) {
		if (!%cl.player.tool[%slot].allowShield && %cl.player.shieldEquipped) {
			%cl.player.unMountImage(1);
		}
		return parent::serverCmdUseTool(%cl, %slot);
	}

	function ProjectileData::onCollision(%data, %obj, %col, %fade, %pos, %normal) {
		if (%col.shieldEquipped && %col.blockProjectiles) {
			%targetVector = vectorNormalize(vectorSub(%obj.getPosition(), %col.getHackPosition()));
			%angle = mACos(vectorDot(%col.getMuzzleVector(0), %targetVector));
			if (%angle < 0.9) {
				%sound = getRandom(1, 1);
				%sound = "weaponDeflectSound" @ %sound;
				serverPlay3D(%sound, %col.getHackPosition());

				%obj.explode();
				return;
			}
		}

		return parent::onCollision(%data, %obj, %col, %fade, %pos, %normal);
	}
};
activatePackage(SwordShield);