//sword.cs
// datablock AudioProfile(swordDrawSound)
// {
//    filename    = "Add-Ons/Weapon_Sword/swordDraw.wav";
//    description = AudioClosest3d;
//    preload = true;
// };
// datablock AudioProfile(swordHitSound)
// {
//    filename    = "Add-Ons/Weapon_Sword/swordHit.wav";
//    description = AudioClosest3d;
//    preload = true;
// };

datablock AudioProfile(WeaponDeflectSound1)
{
   filename    = "./tray3.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(WeaponDeflectSound2)
{
   filename    = "./tray1.wav";
   description = AudioClose3d;
   preload = true;
};



datablock AudioProfile(SwordStabSound1)
{
   filename    = "./stab_1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(SwordStabSound2)
{
   filename    = "./stab_2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(SwordStabSound3)
{
   filename    = "./stab_3.wav";
   description = AudioClose3d;
   preload = true;
};



datablock AudioProfile(heavy_swingSound1)
{
   filename    = "./heavy_swing_1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(heavy_swingSound2)
{
   filename    = "./heavy_swing_2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(heavy_swingSound3)
{
   filename    = "./heavy_swing_3.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(light_swingSound1)
{
   filename    = "./light_swing_1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(light_swingSound2)
{
   filename    = "./light_swing_2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(light_swingSound3)
{
   filename    = "./light_swing_3.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(fast_swingSound)
{
   filename    = "./fast_swing.wav";
   description = AudioClose3d;
   preload = true;
};



datablock AudioProfile(shieldEquipSound)
{
   filename    = "./tray_pullup1.wav";
   description = AudioClose3d;
   preload = true;
};


//effects
datablock ParticleData(SwordSlashChunkParticle)
{
	dragCoefficient      = 2;
	gravityCoefficient   = 1.0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	spinRandomMin = -90;
	spinRandomMax = 90;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/chunk";
	colors[0]     = "0.7 0.7 0.9 0.9";
	colors[1]     = "0.9 0.9 0.9 0.0";
	sizes[0]      = 0.4;
	sizes[1]      = 0.25;
};

datablock ParticleData(SwordSlashStarParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0;
	spinRandomMin = -720;
	spinRandomMax = 720;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/star1";
	colors[0]     = "1 1 0 1";
	colors[1]     = "0.9 0.9 0 0.3";
	sizes[0]      = 0.2;
	sizes[1]      = 0.25;
};

datablock ParticleEmitterData(SwordSlashExplosionEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 6;
	velocityVariance = 1.0;
	ejectionOffset   = 0.0;
	thetaMin         = 0;
	thetaMax         = 180;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "swordSlashChunkParticle SwordSlashStarParticle";

	uiName = "Sword Hit";
};

datablock ExplosionData(SwordSlashExplosion)
{
	lifeTimeMS = 500;

	soundProfile = swordHitSound;

	particleEmitter = swordSlashExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.05;

	faceViewer     = true;
	explosionScale = "1 1 1";

	shakeCamera = true;
	camShakeFreq = "20.0 22.0 20.0";
	camShakeAmp = "1.0 1.0 1.0";
	camShakeDuration = 0.5;
	camShakeRadius = 10.0;

	// Dynamic light
	lightStartRadius = 3;
	lightEndRadius = 0;
	lightStartColor = "0.1 0.2 0.6";
	lightEndColor = "0 0 0";
};


//projectile
datablock ProjectileData(SwordSlashProjectile)
{
	directDamage        = 5;
	directDamageType  = $DamageType::Sword;
	radiusDamageType  = $DamageType::Sword;
	explosion           = SwordSlashExplosion;
	//particleEmitter     = as;

	muzzleVelocity      = 50;
	velInheritFactor    = 1;

	armingDelay         = 0;
	lifetime            = 100;
	fadeDelay           = 70;
	bounceElasticity    = 0;
	bounceFriction      = 0;
	isBallistic         = false;
	gravityMod = 0.0;

	hasLight    = false;
	lightRadius = 3.0;
	lightColor  = "0 0 0";

	uiName = "Sword Slash";
};


datablock ParticleData(SwordSlashDotParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0;
	spinRandomMin = 0;
	spinRandomMax = 1;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/dot";
	colors[0]     = "1 0 0 1";
	colors[1]     = "1 0 0 0.3";
	sizes[0]      = 0.1;
	sizes[1]      = 0.15;
};

datablock ParticleEmitterData(SwordSlashDamageEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 0;
	velocityVariance = 0.0;
	ejectionOffset   = 0.0;
	thetaMin         = 0;
	thetaMax         = 180;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "swordSlashDotParticle";

	uiName = "Sword Damage Indicator";
};

datablock ShapeBaseImageData(SwordSlashDamageImage1){
	shapeFile = "base/data/shapes/empty.dts";
	emap = 0;
	mountPoint = 0;

	stateName[0] 				= "Ready";
	stateTransitionOnTimeout[0] = "FireA";
	stateTimeoutValue[0] 		= 0.01;
	
	stateName[1] 				= "FireA";
	stateEmitter[1] 			= SwordSlashDamageEmitter;
	stateEmitterTime[1] 		= 100;
};

datablock ShapeBaseImageData(SwordSlashDamageImage2 : SwordSlashDamageImage1){
	mountPoint = 1;
};

datablock ShapeBaseImageData(SwordSlashDamageImage3 : SwordSlashDamageImage1){
	mountPoint = 2;
};


////items////


package SwordItemModel {
	function ItemData::onAdd(%this, %obj) {
		%ret = parent::onAdd(%this, %obj);
		if (%this.class !$= "" && %this.isSword) {
			%obj.hideNode("ALL");
			schedule(100, %obj, applySwordProperties, %obj, %this.class);
			%obj.schedule(110, playThread, 0, root);
		}
		return %ret;
	}

	function Item::fadein(%obj, %delay) {
		parent::fadein(%obj, %delay);
		if (%obj.getDatablock().class !$= "" && %delay <= 0 && %obj.getDatablock().isSword) {
			applySwordProperties(%obj, %obj.getDatablock().class);
			// %obj.schedule(1, playThread, 0, root);
			%obj.playThread(0, root);
		}
		return %obj;
	}

	function Armor::onRemove(%this, %obj) {
		if (isObject(%obj.swordBot)) {
			%obj.swordBot.delete();
		}
		if (isObject(%obj.emptyBot)) {
			%obj.emptyBot.delete();
		}

		return parent::onRemove(%this, %obj);
	}

	function Armor::onTrigger(%this, %obj, %trig, %val) {
		if (%obj.getMountedImage(0).class !$= "" && %trig == 4 && %obj.getMountedImage(0).isSword) { //parry
			%sword = %obj.swordBot;
			if (!isObject(%sword)) {
				return parent::onTrigger(%this, %obj, %trig, %val);
			}

			if (!%obj.cannotParry && %val) {
				swordParry(%sword);
			}
		}

		return parent::onTrigger(%this, %obj, %trig, %val);
	}

	function serverCmdUseTool(%cl, %slot) {
		if (%cl.player.tool[%slot].class !$= "") {
			if (getSimTime() - %cl.lastUseTime < 100) {
				cancel(%cl.equipItemSchedule);
				%cl.equipItemSchedule = schedule(150, %cl, serverCmdUseTool, %cl, %slot);
				return;
			}
			%cl.lastUseTime = getSimTime();
		}

		parent::serverCmdUseTool(%cl, %slot);
	}
};
activatePackage(SwordItemModel);


datablock ItemData(ShortSwordItem : HammerItem) {
	shapeFile = "./swords.dts";
	uiName = "Short Sword";

	doColorShift = false;

	class = "ShortSword";
	botDatablock = SwordArmor;

	allowShield = 1;

	isSword = 1;

	iconName = "./icon_ShortSword";
	image = ShortSwordImage;
};

datablock ShapeBaseImageData(ShortSwordImage) {
	shapeFile = "base/data/shapes/empty.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	eyeOffset = 0; //"0.7 1.2 -0.5";

	className = "WeaponImage";
	item = ShortSwordItem;

	class = "ShortSword";
	botDatablock = SwordArmor;

	allowShield = 1;
	isSword = 1;

	//raise your arm up or not
	armReady = true;

	doColorShift = false;


	stateName[0]						= "Activate";
	stateScript[0]						= "onActivate";
	stateTimeoutValue[0]				= 0.5;
	stateTransitionOnTimeout[0]			= "Ready";

	stateName[1]						= "Ready";
	stateTransitionOnTriggerDown[1]		= "Fire";
	stateScript[1]						= "onReady";
	stateAllowImageChange[1]			= true;

	stateName[2]						= "Fire";
	stateTransitionOnTriggerUp[2]		= "Ready";
	stateAllowImageChange[2]			= true;
	stateScript[2]						= "onFire";
};

datablock ItemData(RapierItem : ShortSwordItem) {
	image = RapierImage;

	class = "Rapier";
	uiName = "Rapier";

	allowShield = 0;

	iconName = "./icon_rapier";
};

datablock ShapeBaseImageData(RapierImage : ShortSwordImage) {
	class = "Rapier";

	item = RapierItem;
};

datablock ItemData(LongswordItem : ShortSwordItem) {
	image = LongswordImage;

	class = "Longsword";
	uiName = "Longsword";

	allowShield = 0;

	iconName = "./icon_longsword";
};

datablock ShapeBaseImageData(LongswordImage : ShortSwordImage) {
	class = "Longsword";

	item = LongswordItem;
};

datablock ItemData(KatanaItem : ShortSwordItem) {
	image = KatanaImage;

	class = "Katana";
	uiName = "Katana";

	allowShield = 0;

	iconName = "./icon_katana";
};

datablock ShapeBaseImageData(KatanaImage : ShortSwordImage) {
	class = "Katana";

	item = KatanaItem;
};

datablock ItemData(ScimitarItem : ShortSwordItem) {
	image = ScimitarImage;

	class = "Scimitar";
	uiName = "Scimitar";

	allowShield = 1;

	iconName = "./icon_Scimitar";
};

datablock ShapeBaseImageData(ScimitarImage : ShortSwordImage) {
	class = "Scimitar";

	item = ScimitarItem;
};

function ShortSwordImage::onMount(%this, %obj, %slot) {
	equipSword(%obj, %this.class);
	%obj.triggerDown = 0;
}

function ShortSwordImage::onUnmount(%this, %obj, %slot) {
	%obj.swordBot.delete();
	// %obj.emptyBot.delete();
	%obj.client.applyBodyParts();
	%obj.client.applyBodyColors();
	%obj.triggerDown = 0;
}

function ShortSwordImage::onFire(%this, %obj, %slot) {
	%obj.triggerDown = 1;
	if (!%obj.swordBot.isSwinging) {
		swordSwing(%obj.swordBot);
	}
}

function ShortSwordImage::onReady(%this, %obj, %slot) {
	%obj.triggerDown = 0;
}

function RapierImage::onMount(%this, %obj, %slot) {
	equipSword(%obj, %this.class);
	%obj.triggerDown = 0;
}

function RapierImage::onUnmount(%this, %obj, %slot) {
	%obj.swordBot.delete();
	// %obj.emptyBot.delete();
	%obj.client.applyBodyParts();
	%obj.client.applyBodyColors();
	%obj.triggerDown = 0;
}

function RapierImage::onFire(%this, %obj, %slot) {
	%obj.triggerDown = 1;
	if (!%obj.swordBot.isSwinging) {
		swordSwing(%obj.swordBot);
	}
}

function RapierImage::onReady(%this, %obj, %slot) {
	%obj.triggerDown = 0;
}

function LongswordImage::onMount(%this, %obj, %slot) {
	equipSword(%obj, %this.class);
	%obj.triggerDown = 0;
}

function LongswordImage::onUnmount(%this, %obj, %slot) {
	%obj.swordBot.delete();
	// %obj.emptyBot.delete();
	%obj.client.applyBodyParts();
	%obj.client.applyBodyColors();
	%obj.triggerDown = 0;
}

function LongswordImage::onFire(%this, %obj, %slot) {
	%obj.triggerDown = 1;
	if (!%obj.swordBot.isSwinging) {
		swordSwing(%obj.swordBot);
	}
}

function LongswordImage::onReady(%this, %obj, %slot) {
	%obj.triggerDown = 0;
}

function KatanaImage::onMount(%this, %obj, %slot) {
	equipSword(%obj, %this.class);
	%obj.triggerDown = 0;
}

function KatanaImage::onUnmount(%this, %obj, %slot) {
	%obj.swordBot.delete();
	// %obj.emptyBot.delete();
	%obj.client.applyBodyParts();
	%obj.client.applyBodyColors();
	%obj.triggerDown = 0;
}

function KatanaImage::onFire(%this, %obj, %slot) {
	%obj.triggerDown = 1;
	if (!%obj.swordBot.isSwinging) {
		swordSwing(%obj.swordBot);
	}
}

function KatanaImage::onReady(%this, %obj, %slot) {
	%obj.triggerDown = 0;
}

function ScimitarImage::onMount(%this, %obj, %slot) {
	equipSword(%obj, %this.class);
	%obj.triggerDown = 0;
}

function ScimitarImage::onUnmount(%this, %obj, %slot) {
	%obj.swordBot.delete();
	// %obj.emptyBot.delete();
	%obj.client.applyBodyParts();
	%obj.client.applyBodyColors();
	%obj.triggerDown = 0;
}

function ScimitarImage::onFire(%this, %obj, %slot) {
	%obj.triggerDown = 1;
	if (!%obj.swordBot.isSwinging) {
		swordSwing(%obj.swordBot);
	}
}

function ScimitarImage::onReady(%this, %obj, %slot) {
	%obj.triggerDown = 0;
}